<?php

namespace Shikiryu\Bot\Commands;

use Shikiryu\Bot\Bot;

class Youtubedl implements Icommands
{
    public static function getMessage(Bot $bot, array $data): void
    {
        $action = strtolower($data[1]); // ex: télécharge
        $url = filter_var($data[2], FILTER_VALIDATE_URL, FILTER_FLAG_PATH_REQUIRED); // ex: https://www.youtube.com/watch?v=3BXDsVD6O10
        $type = $data[3]; // ex: audio

        if (empty($url)) {
            $bot->replyPolitely('L\'url n\'est pas conforme');
        }

        if (!in_array($type, ['', 'audio', 'video', 'vidéo'], true)) {
            $bot->replyPolitely('Je n\'ai pas compris ce que je devais faire');
        }

        $youtubedl = self::getYoutubeDl($bot);

        if (in_array($type, ['', 'audio'], true)) {
            $type = 'l\'audio';
            $cmd = sprintf('%s --extract-audio --audio-format mp3 -o %s%s %s', $youtubedl, static::getDownloadFolder($bot), '%(upload_date)s-%(uploader)s-%(title)s.%(ext)s', $url);
            exec($cmd, $output);
            $bot->sendChatMessage('', sprintf('Je lance %s', $cmd));
        } else {
            $type = 'la vidéo';
            $cmd = sprintf('%s -f bestvideo+bestaudio/best -o %s%s %s', $youtubedl, static::getDownloadFolder($bot), '%(upload_date)s-%(uploader)s-%(title)s.%(ext)s', $url);
            exec($cmd, $output);
            $bot->sendChatMessage('', sprintf('Je lance %s', $cmd));
        }
        $bot->replyPolitely(sprintf('Je %s %s', $action, $type));
    }

    public static function getDescription(): string
    {
        return 'Youtubedl wrapper';
    }

    private static function getYoutubeDl(Bot $bot): string
    {
        $youtubedl_bin = $bot->getConfig()['youtube-dl']['bin'];
        if (empty($youtubedl_bin)) {
            exec('which youtube-dl', $output);
            $youtubedl_bin = current($output);
        }

        return $youtubedl_bin;
    }

    private static function getDownloadFolder(Bot $bot): string
    {
        return $bot->getConfig()['youtube-dl']['folder'] ?? __DIR__.'/../../';
    }

}
